﻿'Programed by NAS6


'惑星
Public Class Planet
    Public m_earth As Planet

    Public m_pno As Integer
    Public m_dat0 As DateTime
    Public m_nday As Double
    Public m_a As Double
    Public m_e As Double
    Public m_l0 As Double
    Public m_nperday As Double
    Public m_ra As Double
    Public m_rb As Double
    Public m_t As Double
    Public m_s As Double
    Public m_i As Double
    Public m_w As Double
    Public CNST_G As Double = 0.00000000006673
    Public CNST_C As Double = 299792458.0
    Public CNST_AU As Double = 149597870700.0
    Public CNST_DR As Double = 0.017453292519943
    Public CNST_TAU As Double = 499.004782


    Public m_m As Double
    Public m_r As Double

    Public x0 As Vector
    Public ex As Vector

    Public m_el As Double
    Public m_d As Double

    Public m_asc As Double
    Public m_hs() As Double

    Public m_rev As Boolean


    'コンストラクタ
    Public Sub New()
        x0 = New Vector(3)
        ex = New Vector(3)
    End Sub

    'コンストラクタ地球
    Public Sub New(ByVal pno As Integer, ByVal nday As Double, ByVal dat0 As DateTime, ByVal aa As Double, ByVal ae As Double, ByVal al0 As Double, ByVal anperday As Double, ByVal ara As Double, ByVal arb As Double, ByVal at As Double, ByVal aas As Double, ByVal ai As Double, ByVal aw As Double, ByVal am As Double, ByVal ar As Double)
        m_pno = pno
        m_dat0 = dat0
        m_nday = nday
        m_a = aa
        m_e = ae
        m_l0 = al0
        m_nperday = anperday
        m_ra = ara
        m_rb = arb
        m_t = at
        m_s = aas
        m_i = ai
        m_w = aw
        m_m = am
        m_r = ar
        m_earth = Me
        m_rev = False

        x0 = New Vector(3)
        ex = New Vector(3)

        Init(nday)
    End Sub


    'コンストラクタ惑星
    Public Sub New(ByVal pno As Integer, ByVal nday As Double, ByVal dat0 As DateTime, ByVal aa As Double, ByVal ae As Double, ByVal al0 As Double, ByVal anperday As Double, ByVal ara As Double, ByVal arb As Double, ByVal at As Double, ByVal aas As Double, ByVal ai As Double, ByVal aw As Double, ByVal am As Double, ByVal ar As Double, ByVal earth As Planet)
        m_pno = pno
        m_dat0 = dat0
        m_nday = nday
        m_a = aa
        m_e = ae
        m_l0 = al0
        m_nperday = anperday
        m_ra = ara
        m_rb = arb
        m_t = at
        m_s = aas
        m_i = ai
        m_w = aw
        m_m = am
        m_r = ar
        m_earth = earth
        m_rev = False

        x0 = New Vector(3)
        ex = New Vector(3)

        'リバース判定用
        m_earth.recompute(nday - 1.0)
        Init(nday - 1.0)

        ex = New Vector(3)
        ex.x(0) = x0.x(0) - m_earth.x0.x(0)
        ex.x(1) = x0.x(1) - m_earth.x0.x(1)
        ex.x(2) = x0.x(2) - m_earth.x0.x(2)

        m_el = Math.Atan(ex.x(1) / ex.x(0))
        If ex.x(0) < 0.0 Then
            m_el = m_el + Math.PI
        End If
        m_el = (m_el / CNST_DR) Mod 360.0
        If m_el < 0.0 Then
            m_el = m_el + 360.0
        End If


        Dim xx As Double = m_el


        x0 = New Vector(3)
        ex = New Vector(3)

        '地球位置再計算して計算
        m_earth.recompute(nday)
        Init(nday)

        ex.x(0) = x0.x(0) - m_earth.x0.x(0)
        ex.x(1) = x0.x(1) - m_earth.x0.x(1)
        ex.x(2) = x0.x(2) - m_earth.x0.x(2)

        m_el = Math.Atan(ex.x(1) / ex.x(0))
        If ex.x(0) < 0.0 Then
            m_el = m_el + Math.PI
        End If
        m_el = (m_el / CNST_DR) Mod 360.0
        If m_el < 0.0 Then
            m_el = m_el + 360.0
        End If

        '惑星光行差
        m_d = ex.Abs()
        Dim tau = m_d * CNST_TAU / 86400.0

        Init(nday - tau)

        ex = New Vector(3)
        ex.x(0) = x0.x(0) - m_earth.x0.x(0)
        ex.x(1) = x0.x(1) - m_earth.x0.x(1)
        ex.x(2) = x0.x(2) - m_earth.x0.x(2)

        m_el = Math.Atan(ex.x(1) / ex.x(0))
        If ex.x(0) < 0.0 Then
            m_el = m_el + Math.PI
        End If
        m_el = (m_el / CNST_DR) Mod 360.0
        If m_el < 0.0 Then
            m_el = m_el + 360.0
        End If

        m_d = ex.Abs()
        ex.x(0) = ex.x(0) / CNST_DR
        ex.x(1) = ex.x(1) / CNST_DR
        ex.x(2) = ex.x(2) / CNST_DR



        If (0.0 < xx - m_el And xx < 359.0) Or (xx - m_el < 0.0 And 359.0 < xx And m_el < 1.0) Then
            m_rev = True
        End If


    End Sub

    'コンストラクタ月
    Public Sub New(ByVal pno As Integer, ByVal nday As Double, ByVal dat0 As DateTime, ByVal add As Double, ByVal earth As Planet, ByVal bbb As Boolean)
        m_pno = pno
        m_dat0 = dat0
        m_nday = nday + add
        m_a = 0.0
        m_e = 0.0
        m_l0 = 0.0
        m_nperday = 0.0
        m_ra = 0.0
        m_rb = 0.0
        m_t = 0.0
        m_s = 0.0
        m_i = 0.0
        m_w = 0.0
        m_m = 0.0
        m_r = 0.0
        m_earth = earth
        m_el = 0.0
        m_d = 0.0
        m_rev = False

        x0 = New Vector(3)


        Dim dat1 As New DateTime(1974, 12, 31, 0, 0, 0)
        Dim days As Double = Math.Ceiling(m_nday)
        Dim times As Double = m_nday - days
        Dim hh As Double = Math.Floor(times * 24.0)
        Dim mm As Double = Math.Floor(times * 24.0 * 60.0) Mod 60
        Dim ss As Double = Math.Floor(times * 24.0 * 60.0 * 60.0) Mod 60
        Dim ts As New TimeSpan(days, hh, mm, ss)
        Dim dat As DateTime = dat0 + ts
        Dim dats As TimeSpan = dat - dat1
        Dim z As Double = dats.TotalDays
        Dim tt As Double = z / 365.25
        Dim t As Double = tt + (0.0317 * tt + 1.43) * 0.000001

        hh = Math.Floor(times * 24.0)
        mm = Math.Floor(times * 24.0 * 60.0) Mod 60
        ss = Math.Floor(times * 24.0 * 60.0 * 60.0) Mod 60
        ts = New TimeSpan(days, hh, mm, ss)
        dat = dat0 + ts
        dats = dat - dat1
        z = dats.TotalDays
        tt = z / 365.25
        t = tt + (0.0317 * tt + 1.43) * 0.000001

        'リバース判定用
        If 30 < mm Then
            mm = mm - 30
        Else
            mm = mm + 30
            If Not hh = 0 Then
                hh = hh - 1
            Else
                hh = 23
                days = days - 1
            End If
        End If

        ts = New TimeSpan(days, hh, mm, ss)
        dat = dat0 + ts
        dats = dat - dat1
        z = dats.TotalDays
        tt = z / 365.25
        t = tt + (0.0317 * tt + 1.43) * 0.000001

        InitMoon(t)

        m_el = ex.x(0) Mod 360.0
        If m_el < 0.0 Then
            m_el = m_el + 360.0
        End If

        Dim xx As Double = m_el

        '再計算
        hh = Math.Floor(times * 24.0)
        mm = Math.Floor(times * 24.0 * 60.0) Mod 60
        ss = Math.Floor(times * 24.0 * 60.0 * 60.0) Mod 60
        ts = New TimeSpan(days, hh, mm, ss)
        dat = dat0 + ts
        dats = dat - dat1
        z = dats.TotalDays
        tt = z / 365.25
        t = tt + (0.0317 * tt + 1.43) * 0.000001

        InitMoon(t)

        m_el = ex.x(0) Mod 360.0
        If m_el < 0.0 Then
            m_el = m_el + 360.0
        End If


        If (0.0 < xx - m_el And xx < 359.0) Or (xx - m_el < 0.0 And 359.0 < xx And m_el < 1.0) Then
            m_rev = True
        End If
    End Sub

    'コンストラクタ星座
    Public Sub New(ByVal pno As Integer, ByVal nday As Double, ByVal dat0 As DateTime, ByVal ax As Double, ByVal earth As Planet)
        m_pno = pno
        m_dat0 = dat0
        m_nday = nday
        m_a = 0.0
        m_e = 0.0
        m_l0 = 0.0
        m_nperday = 0.0
        m_ra = 0.0
        m_rb = 0.0
        m_t = 0.0
        m_s = 0.0
        m_i = 0.0
        m_w = 0.0
        m_m = 0.0
        m_r = 0.0
        m_earth = earth
        m_el = ax
        m_d = 0.0
        m_rev = False

        x0 = New Vector(3)
        ex = New Vector(3)

        ex.x(0) = ax
        ex.x(1) = 0.0
        ex.x(2) = 0.0
    End Sub

    'コンストラクタリリスドラゴンヘッドドラゴンテイルascmc
    Public Sub New(ByVal pno As Integer, ByVal nday As Double, ByVal dat0 As DateTime, ByVal sw As Integer, ByVal earth As Planet)
        m_pno = pno
        m_dat0 = dat0
        m_nday = nday
        m_a = 0.0
        m_e = 0.0
        m_l0 = 0.0
        m_nperday = 0.0
        m_ra = 0.0
        m_rb = 0.0
        m_t = 0.0
        m_s = 0.0
        m_i = 0.0
        m_w = 0.0
        m_m = 0.0
        m_r = 0.0
        m_earth = earth
        m_el = 0.0
        m_d = 0.0
        m_rev = False

        x0 = New Vector(3)
        ex = New Vector(3)

        If sw = 0 Then 'リリス
            Dim dat As New DateTime(1996, 7, 1)
            m_nperday = (0.975) * (131.1 - 120.53) / (92.0)
            m_el = (120.53 + m_nperday * nday) Mod 360.0
            If m_el < 0.0 Then
                m_el = m_el + 360.0
            End If
            ex.x(0) = m_el
        ElseIf sw = 1 Then 'ドラゴンヘッド
            Dim dat As New DateTime(1996, 7, 1)
            m_nperday = (187.56 - 192.48) / (92.0)
            m_el = (192.48 + m_nperday * nday) Mod 360.0
            If m_el < 0.0 Then
                m_el = m_el + 360.0
            End If
            ex.x(0) = m_el
            m_rev = True
        ElseIf sw = 2 Then 'ドラゴンテイル
            Dim dat As New DateTime(1996, 7, 1)
            m_nperday = (187.56 - 192.48) / (92.0)
            m_el = (192.48 + m_nperday * nday + 180.0) Mod 360.0
            If m_el < 0.0 Then
                m_el = m_el + 360.0
            End If
            ex.x(0) = m_el
            m_rev = True
        ElseIf sw = 3 Then 'asc何も入らないPlanet(i,0).m_hs(0)に入ってる
            m_el = 0.0
            If m_el < 0.0 Then
                m_el = m_el + 360.0
            End If
            ex.x(0) = m_el
        ElseIf sw = 4 Then 'mc何も入らないPlanet(i,0).m_hs(9)に入ってる
            m_el = 0.0
            If m_el < 0.0 Then
                m_el = m_el + 360.0
            End If
            ex.x(0) = m_el
        End If
    End Sub

    '地球再計算
    Public Sub recompute(ByVal nday As Double)
        m_nday = nday
        x0 = New Vector(3)
        ex = New Vector(3)

        Init(nday)
    End Sub

    '月初期化
    Public Sub InitMoon(ByVal t As Double)
        ex = New Vector(3)
        'Inputed data by MIJU
        Dim a As Double = 0.004 * Math.Sin(93.8 - 1.33 * t) _
                       + 0.002 * Math.Sin(248.6 - 19.34 * t) _
                       + 0.0006 * Math.Sin(66.0 + 0.2 * t) _
                       + 0.0006 * Math.Sin(249.0 - 19.3 * t)

        ex.x(0) = 124.8754 + 4812.67881 * t _
                       + 6.2887 * Math.Sin(338.915 + 4771.9886 * t + a) _
                       + 1.274 * Math.Sin(107.248 - 4133.3526 * t) _
                       + 0.6583 * Math.Sin(51.668 + 8905.3422 * t) _
                       + 0.2136 * Math.Sin(317.831 + 9543.9773 * t) _
                       + 0.1856 * Math.Sin(176.531 + 359.9905 * t) _
 _
                       + 0.1143 * Math.Sin(292.463 + 9664.0404 * t) _
                       + 0.0588 * Math.Sin(86.16 + 638.635 * t) _
                       + 0.0572 * Math.Sin(103.78 - 3773.363 * t) _
                       + 0.0533 * Math.Sin(30.58 + 13677.331 * t) _
                       + 0.0459 * Math.Sin(124.86 - 8545.352 * t) _
 _
                       + 0.041 * Math.Sin(342.38 + 4411.998 * t) _
                       + 0.0348 * Math.Sin(25.83 + 4452.671 * t) _
                       + 0.0305 * Math.Sin(155.45 + 5131.979 * t) _
                       + 0.0153 * Math.Sin(240.79 + 758.698 * t) _
                       + 0.0125 * Math.Sin(271.38 + 14436.029 * t) _
 _
                       + 0.011 * Math.Sin(226.45 - 4892.052 * t) _
                       + 0.0107 * Math.Sin(55.58 - 13038.696 * t) _
                       + 0.01 * Math.Sin(296.75 + 14315.966 * t) _
                       + 0.0085 * Math.Sin(34.5 - 8266.71 * t) _
                       + 0.0079 * Math.Sin(290.7 - 4493.34 * t) _
 _
                       + 0.0068 * Math.Sin(228.2 + 9265.33 * t) _
                       + 0.0052 * Math.Sin(133.1 + 319.32 * t) _
                       + 0.005 * Math.Sin(202.4 + 4812.66 * t) _
                       + 0.0048 * Math.Sin(68.6 - 19.34 * t) _
                       + 0.004 * Math.Sin(34.1 + 13317.34 * t) _
 _
                       + 0.004 * Math.Sin(9.5 + 18449.32 * t) _
                       + 0.004 * Math.Sin(93.8 - 1.33 * t) _
                       + 0.0039 * Math.Sin(103.3 + 17810.68 * t) _
                       + 0.0037 * Math.Sin(65.1 + 5410.62 * t) _
                       + 0.0027 * Math.Sin(321.3 + 9183.99 * t) _
 _
                       + 0.0026 * Math.Sin(174.8 - 13797.39 * t) _
                       + 0.0024 * Math.Sin(82.7 + 998.63 * t) _
                       + 0.0024 * Math.Sin(4.7 + 9224.66 * t) _
                       + 0.0022 * Math.Sin(121.4 - 8185.36 * t) _
                       + 0.0021 * Math.Sin(134.4 + 9903.97 * t) _
 _
                       + 0.0021 * Math.Sin(173.1 + 719.98 * t) _
                       + 0.0021 * Math.Sin(100.3 - 3413.37 * t) _
                       + 0.002 * Math.Sin(248.6 - 19.34 * t) _
                       + 0.0018 * Math.Sin(98.1 + 4013.29 * t) _
                       + 0.0016 * Math.Sin(344.1 + 18569.38 * t) _
 _
                       + 0.0012 * Math.Sin(52.1 - 12678.71 * t) _
                       + 0.0011 * Math.Sin(250.3 + 19208.02 * t) _
                       + 0.0009 * Math.Sin(81.0 - 8586.0 * t) _
                       + 0.0008 * Math.Sin(207.0 + 14037.3 * t) _
                       + 0.0008 * Math.Sin(31.0 - 7906.7 * t) _
 _
                       + 0.0007 * Math.Sin(346.0 + 4052.0 * t) _
                       + 0.0007 * Math.Sin(294.0 - 4853.3 * t) _
                       + 0.0007 * Math.Sin(90.0 + 278.6 * t) _
                       + 0.0006 * Math.Sin(237.0 + 1118.7 * t) _
                       + 0.0005 * Math.Sin(82.0 + 22582.7 * t) _
 _
                       + 0.0005 * Math.Sin(276.0 + 19088.0 * t) _
                       + 0.0005 * Math.Sin(73.0 - 17450.7 * t) _
                       + 0.0005 * Math.Sin(112.0 + 5091.3 * t) _
                       + 0.0004 * Math.Sin(116.0 - 398.7 * t) _
                       + 0.0004 * Math.Sin(25.0 - 120.1 * t) _
 _
                       + 0.0004 * Math.Sin(181.0 + 9584.7 * t) _
                       + 0.0004 * Math.Sin(18.0 + 720.0 * t) _
                       + 0.0003 * Math.Sin(60.0 - 3814.0 * t) _
                       + 0.0003 * Math.Sin(13.0 - 3494.7 * t) _
                       + 0.0003 * Math.Sin(13.0 + 18089.3 * t) _
 _
                       + 0.0003 * Math.Sin(152.0 + 5492.0 * t) _
                       + 0.0003 * Math.Sin(317.0 - 40.7 * t) _
                       + 0.0003 * Math.Sin(348.0 + 23221.3 * t)

        Dim b As Double = 0.0267 * Math.Sin(68.64 - 19.341 * t) _
                        + 0.0043 * Math.Sin(342.0 - 19.36 * t) _
                        + 0.004 * Math.Sin(93.8 - 1.33 * t) _
                        + 0.002 * Math.Sin(248.6 - 19.34 * t) _
                        + 0.0005 * Math.Sin(358.0 - 19.4 * t)

        ex.x(1) = 5.1282 * Math.Sin(236.231 + 4832.0202 * t + b) _
                       + 0.2806 * Math.Sin(215.147 + 9604.0088 * t) _
                       + 0.2777 * Math.Sin(77.316 + 60.0316 * t) _
                       + 0.1732 * Math.Sin(4.563 - 4073.322 * t) _
                       + 0.0554 * Math.Sin(308.98 + 8965.374 * t) _
 _
                       + 0.0463 * Math.Sin(343.48 + 698.667 * t) _
                       + 0.0326 * Math.Sin(287.9 + 13737.362 * t) _
                       + 0.0172 * Math.Sin(194.06 + 14375.997 * t) _
                       + 0.0093 * Math.Sin(25.6 - 8845.31 * t) _
                       + 0.0088 * Math.Sin(98.4 - 4711.96 * t) _
 _
                       + 0.0082 * Math.Sin(1.1 - 3713.33 * t) _
                       + 0.0043 * Math.Sin(322.4 + 5470.66 * t) _
                       + 0.0042 * Math.Sin(266.8 + 18509.35 * t) _
                       + 0.0034 * Math.Sin(188.0 - 4433.31 * t) _
                       + 0.0025 * Math.Sin(312.5 + 8605.38 * t) _
 _
                       + 0.0022 * Math.Sin(291.4 + 13377.37 * t) _
                       + 0.0021 * Math.Sin(340.0 + 1058.66 * t) _
                       + 0.0019 * Math.Sin(218.6 + 9244.02 * t) _
                       + 0.0018 * Math.Sin(291.8 - 8206.68 * t) _
                       + 0.0018 * Math.Sin(52.8 + 5192.01 * t) _
 _
                       + 0.0017 * Math.Sin(168.7 + 14496.06 * t) _
                       + 0.0016 * Math.Sin(73.8 + 420.02 * t) _
                       + 0.0015 * Math.Sin(262.1 + 9284.69 * t) _
                       + 0.0015 * Math.Sin(31.7 + 9964.0 * t) _
                       + 0.0014 * Math.Sin(260.8 - 299.96 * t) _
 _
                       + 0.0013 * Math.Sin(239.7 + 4472.03 * t) _
                       + 0.0013 * Math.Sin(30.4 + 379.35 * t) _
                       + 0.0012 * Math.Sin(304.9 + 4812.68 * t) _
                       + 0.0012 * Math.Sin(12.4 - 4851.36 * t) _
                       + 0.0011 * Math.Sin(173.0 + 19147.99 * t) _
 _
                       + 0.001 * Math.Sin(312.9 - 12978.66 * t) _
                       + 0.0008 * Math.Sin(1.0 + 17870.7 * t) _
                       + 0.0008 * Math.Sin(190.0 + 9724.1 * t) _
                       + 0.0007 * Math.Sin(22.0 + 13098.7 * t) _
                       + 0.0006 * Math.Sin(117.0 + 5590.7 * t) _
 _
                       + 0.0006 * Math.Sin(47.0 - 13617.3 * t) _
                       + 0.0005 * Math.Sin(22.0 - 8485.3 * t) _
                       + 0.0005 * Math.Sin(150.0 + 4193.4 * t) _
                       + 0.0004 * Math.Sin(119.0 - 9483.9 * t) _
                       + 0.0004 * Math.Sin(246.0 + 23281.3 * t) _
 _
                       + 0.0004 * Math.Sin(301.0 + 10242.6 * t) _
                       + 0.0004 * Math.Sin(126.0 + 9325.4 * t) _
                       + 0.0004 * Math.Sin(104.0 + 14097.4 * t) _
                       + 0.0003 * Math.Sin(340.0 + 22642.7 * t) _
                       + 0.0003 * Math.Sin(270.0 + 18149.4 * t) _
 _
                       + 0.0003 * Math.Sin(358.0 - 3353.3 * t) _
                       + 0.0003 * Math.Sin(148.0 + 19268.0 * t)

        ex.x(2) = 0.0
    End Sub

    '惑星初期化
    Public Sub Init(ByVal nday As Double)
        Dim xx As Vector = New Vector(3)
        Dim f As Double = kepler(nday, xx)
        x0 = New Vector(3)
        x0.x(0) = xx.x(0)
        x0.x(1) = xx.x(1)
        x0.x(2) = xx.x(2)



        Dim xyz As Vector = New Vector(3)
        ecliptic(x0.x(0), x0.x(1), x0.x(2), xyz)
        If Double.IsNaN(xyz.x(0)) Or Double.IsNaN(xyz.x(1)) Or Double.IsNaN(xyz.x(2)) Then
            x0.x(0) = 0.0
            x0.x(1) = 0.0
            x0.x(2) = 0.0
        Else
            x0.x(0) = xyz.x(0)
            x0.x(1) = xyz.x(1)
            x0.x(2) = xyz.x(2)
        End If

        ex = New Vector(3)

        m_el = 0.0
        m_d = 0.0
    End Sub

    'ケプラー方程式
    Public Function kepler(ByVal nday As Double, ByRef xx As Vector) As Double
        xx = xx.ZeroVec()

        If m_pno = 1 Then
            Return 0.0
        End If

        If nday < 0.0 Then '1996年以前
            m_l0 = m_l0 + 360.0 * 1000.0
            If m_nperday * nday + m_l0 < 0.0 Then
                MessageBox.Show("too past day!", "error")
                Return 0.0
            End If
        End If

        Dim m As Double
        Dim u As Double
        Dim du As Double
        Dim x As Double
        Dim y As Double

        'm: 平均近点角(mean anomaly)
        'u: 離心近点角(eccentric anomaly)
        'e: 離心率
        'a: 軌道長半径
        'n: 平均運動

        m = m_nperday * nday + m_l0

        m = m * CNST_DR

        Dim e2 As Double = m_e * m_e
        Dim e3 As Double = m_e * m_e * m_e
        Dim e4 As Double = m_e * m_e * m_e * m_e
        Dim e5 As Double = m_e * m_e * m_e * m_e * m_e
        Dim e6 As Double = m_e * m_e * m_e * m_e * m_e * m_e
        Dim e7 As Double = m_e * m_e * m_e * m_e * m_e * m_e * m_e

        '近似式 e = 0.5 くらいまで。彗星のように e = 1.0 に近いと崩れる。
        u = m + (m_e - 1.0 / 8.0 * e3 + 1.0 / 192.0 * e5 - 1.0 / 9216.0 * e7) * Math.Sin(m) _
              + (1.0 / 2.0 * e2 - 1.0 / 6.0 * e4 + 1.0 / 48.0 * e6) * Math.Sin(2.0 * m) _
              + (3.0 / 8.0 * e3 - 27.0 / 128.0 * e5 + 243.0 / 5120.0 * e7) * Math.Sin(3.0 * m) _
              + (1.0 / 3.0 * e4 - 4.0 / 15.0 * e6) * Math.Sin(4.0 * m) _
              + (125.0 / 384.0 * e5 - 3125.0 / 9216.0 * e7) * Math.Sin(5.0 * m) _
              + 27.0 / 80.0 * e6 * Math.Sin(6.0 * m) _
              + 16807.0 / 46080.0 * e7 * Math.Sin(7.0 * m)

        '上の近似式で得られた値を元に以下の関数を繰り返して誤差が小さくなるまで繰り返す
        '天体の位置計算 増補版 p147
        Dim lp As Integer = 0
        While True
            du = (m - u + m_e * Math.Sin(u)) / (1.0 - m_e * Math.Cos(u))
            u = u + du
            If Math.Abs(du) < 0.0000001 Then
                Exit While
            End If
            lp = lp + 1
        End While

        Dim ree As Double = Math.Sqrt(1.0 - e2)

        Dim tanf As Double = ree * Math.Sin(u) / (Math.Cos(u) - m_e)
        Dim f As Double = Math.Atan(tanf)
        If Math.Cos(u) - m_e < 0.0 Then
            f = f + Math.PI
        End If
        Dim fd As Double = f / CNST_DR
        'Dim r0 As Double = m_a * (1.0 - m_e * Math.Cos(u))

        'x = m_a * (Math.Cos(u) - m_e)
        'y = m_a * ree * Math.Sin(u)
        Dim r0 As Double = m_a * (1.0 - e2) / (1.0 + m_e * Math.Cos(f))

        x = r0 * Math.Cos(f)
        y = r0 * Math.Sin(f)

        xx = New Vector(3)
        xx.x(0) = x
        xx.x(1) = y
        xx.x(2) = 0.0

        Return f
    End Function

    'xyz系を日心黄道直交座標系に変換
    Public Sub ecliptic(ByVal x As Double, ByVal y As Double, ByVal z As Double, ByRef xyz As Vector)
        If Not xyz.x.Length = 3 Then
            Return
        End If
        Dim dr As Double = 0.017453292519943
        Dim ss As Double = m_s * dr
        Dim ii As Double = m_i * dr
        Dim ww As Double = m_w * dr
        's: 昇交点黄経 Ω
        'i: 軌道傾斜角 i 
        'w: 近日点引数 ω

        Dim vec As Vector = New Vector(3)
        vec.x(0) = x * (Math.Cos(ss) * Math.Cos(ww) - Math.Sin(ss) * Math.Cos(ii) * Math.Sin(ww)) - y * (Math.Cos(ss) * Math.Sin(ww) + Math.Sin(ss) * Math.Cos(ii) * Math.Cos(ww))
        vec.x(1) = x * (Math.Sin(ss) * Math.Cos(ww) + Math.Cos(ss) * Math.Cos(ii) * Math.Sin(ww)) - y * (Math.Sin(ss) * Math.Sin(ww) - Math.Cos(ss) * Math.Cos(ii) * Math.Cos(ww))
        vec.x(2) = x * Math.Sin(ii) * Math.Sin(ww) + y * Math.Sin(ii) * Math.Cos(ww)

        'vec.x(0) = x
        'vec.x(1) = y
        'vec.x(2) = 0.0


        'ベクトル回転
        'vec = vec.RotAxis(vec.UnitVec(2), ss).RotAxis(vec.UnitVec(0), ii).RotAxis(vec.UnitVec(2), ww)

        'vec.x(0) = x
        'vec.x(1) = y
        'vec.x(2) = 0.0

        '行列回転
        'Dim mat As Matrix = New Matrix(3)
        'mat = mat.UnitMat().RotAxisMat(vec.UnitVec(2), ss).RotAxisMat(vec.UnitVec(0), ii).RotAxisMat(vec.UnitVec(2), ww)
        'vec = mat * vec


        xyz.x(0) = vec.x(0)
        xyz.x(1) = vec.x(1)
        xyz.x(2) = vec.x(2)
    End Sub


    'double絶対値
    Public Function fabs(ByVal x As Double) As Double
        fabs = x
        If fabs < 0.0 Then
            fabs = -fabs
        End If
    End Function

    'アセンダント計算
    Public Sub asc(ByVal dat1 As DateTime)
        Dim dat As New DateTime(1996, 7, 1, 0, 0, 0)
        m_asc = 150.0
        Dim t As TimeSpan = dat1 - dat
        Dim td As Double = t.Days
        Dim d As Double
        d = td Mod 365.25
        If d < 0.0 Then
            d = d + 365.25
        End If
        d = d / 365.25 * 360.0
        Dim hh As Double = t.Hours
        Dim mm As Double = t.Minutes
        Dim ss As Double = t.Seconds
        Dim ff As Double = hh / 24.0 + mm / 1440.0 + ss / 86400.0
        Dim f As Double = ff * 361.0
        m_asc = (m_asc + d + f) Mod 360.0
        If m_asc < 0.0 Then
            m_asc = m_asc + 360.0
        End If
    End Sub

    'ハウス計算
    Public Sub house(ByVal aasc As Double)
        ReDim m_hs(11)
        m_hs(0) = aasc
        m_hs(1) = m_hs(0) + 22.0
        m_hs(1) = m_hs(1) Mod 360.0
        If m_hs(1) < 0.0 Then
            m_hs(1) = m_hs(1) + 360.0
        End If
        m_hs(2) = m_hs(1) + 25.0
        m_hs(2) = m_hs(2) Mod 360.0
        If m_hs(2) < 0.0 Then
            m_hs(2) = m_hs(2) + 360.0
        End If
        m_hs(3) = m_hs(2) + 31.0
        m_hs(3) = m_hs(3) Mod 360.0
        If m_hs(3) < 0.0 Then
            m_hs(3) = m_hs(3) + 360.0
        End If
        m_hs(4) = m_hs(3) + 36.0
        m_hs(4) = m_hs(4) Mod 360.0
        If m_hs(4) < 0.0 Then
            m_hs(4) = m_hs(4) + 360.0
        End If
        m_hs(5) = m_hs(4) + 35.0
        m_hs(5) = m_hs(5) Mod 360.0
        If m_hs(5) < 0.0 Then
            m_hs(5) = m_hs(5) + 360.0
        End If
        m_hs(6) = m_hs(5) + 31.0
        m_hs(6) = m_hs(6) Mod 360.0
        If m_hs(6) < 0.0 Then
            m_hs(6) = m_hs(6) + 360.0
        End If
        m_hs(7) = m_hs(6) + 22.0
        m_hs(7) = m_hs(7) Mod 360.0
        If m_hs(7) < 0.0 Then
            m_hs(7) = m_hs(7) + 360.0
        End If
        m_hs(8) = m_hs(7) + 25.0
        m_hs(8) = m_hs(8) Mod 360.0
        If m_hs(8) < 0.0 Then
            m_hs(8) = m_hs(8) + 360.0
        End If
        m_hs(9) = m_hs(8) + 31.0
        m_hs(9) = m_hs(9) Mod 360.0
        If m_hs(9) < 0.0 Then
            m_hs(9) = m_hs(9) + 360.0
        End If
        m_hs(10) = m_hs(9) + 36.0
        m_hs(10) = m_hs(10) Mod 360.0
        If m_hs(10) < 0.0 Then
            m_hs(10) = m_hs(10) + 360.0
        End If
        m_hs(11) = m_hs(10) + 35.0
        m_hs(11) = m_hs(11) Mod 360.0
        If m_hs(11) < 0.0 Then
            m_hs(11) = m_hs(11) + 360.0
        End If
    End Sub

End Class
